//This file is part of AcetoneISO. Copyright 2006,2007,2008,2009 Fabrizio Di Marco and Marco Di Antonio  (acetoneiso@gmail.com)
//
//    AcetoneISO is free software: you can redistribute it and/or modify
//    it under the terms of the GNU General Public License as published by
//    the Free Software Foundation, either version 3 of the License, or
//    (at your option) any later version.
//
//    AcetoneISO is distributed in the hope that it will be useful,
//    but WITHOUT ANY WARRANTY; without even the implied warranty of
//    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//    GNU General Public License for more details.
//
//    You should have received a copy of the GNU General Public License
//    along with AcetoneISO.  If not, see <http://www.gnu.org/licenses/>.
#include <QtGui>
#include <QTabWidget>
#include <QWebView>
#include "acetoneiso.h"
#include <fcntl.h>
#include <iostream>
#include <QProcess>
#include <QUrl>
#include <QProgressBar>
#include"md5check.h"
#include"mount.h"
#include"encrypt.h"
#include"foldertoiso.h"
#include"donate.h"
#include"psxrip.h"
#include"compress.h"
#include"converter.h"
#include"isocd.h"
#include"split.h"
#include"play.h"
#include"gencue.h"
#include"database.h"
#include"gmount.h"
#include"eltorito.h"
#include"backup_audio.h"
#include"messages.h"
#include"open_mounted.h"
#include"status_mounted.h"
#include"options.h"
#include"about.h"
#include"progress.h"
#include"manual.h"
#include"udf.h"
#include"vidgen.h"
#include"utube.h"
#include"audiotools.h"
#include"umount_check.h"
#include"iso_from_pcgame.h"
#include"leggirigo.h"

acetoneiso::acetoneiso()
{
QPixmap splashpng(":/images/splash.png");
QSplashScreen *splash = new QSplashScreen(splashpng);
splash->show();
splash->showMessage(tr("Loading GUI..."));


  QDir Temp = QDir::temp();
  Temp.mkdir("acetoneiso");
  //Temp.mkdir("acetoneiso_burn");

  QDir Home = QDir::home();
  Home.mkdir("virtual-drives");
  Home.cd("virtual-drives");
  Home.mkdir("1");
  Home.mkdir("2");
  Home.mkdir("3");
  Home.mkdir("4");
  Home.mkdir("5");
  Home.mkdir("6");
  Home.mkdir("7");
  Home.mkdir("dvd");
  Home.mkdir("../.acetoneiso");
  Home.cd(".acetoneiso");



    setupUi(this); // this sets up GUI
    setDockInit();
    status_mounted(); //questa funzione va prima del montaggio da cml altrimenti ho una doppia entry nel montaggio da terminale
    cmlMount();


    connect( actionConvert_MacOs_Image_2, SIGNAL ( triggered() ), this, SLOT ( macimg() ) );
    connect( pushButton, SIGNAL( clicked() ), this, SLOT( mount() ) ); 
    connect( pushButton_2, SIGNAL( clicked() ), this, SLOT( umount() ) ); 
   // connect( pushButton_3, SIGNAL( clicked() ), this, SLOT( a_donate() ) );
    connect( pushButton_4, SIGNAL( triggered() ), this, SLOT( extract() ) ); 
    connect( actionMount_Image, SIGNAL( triggered() ), this, SLOT( mount() ) );
    connect( actionDonate, SIGNAL( triggered() ), this, SLOT( a_donate() ) );
    connect( actionExit, SIGNAL( triggered() ), qApp, SLOT( quit() ) );
    connect( pushButton_Omni_3, SIGNAL( triggered() ), this, SLOT( converter() ) );
    connect( pushButton_IsoFromFolder_2, SIGNAL( triggered() ), this, SLOT( foldertoiso() ) );
    connect( actionA_protected_CD_DVD, SIGNAL( triggered() ), this, SLOT( isopcgame() ) );
    connect( pushButton_PSX_Rip, SIGNAL( triggered() ), this, SLOT( psxrip() ) );
    connect( button_backup_audio_2, SIGNAL( triggered() ), this, SLOT( backupaudio() ) );
    connect( actionCompress, SIGNAL( triggered() ), this, SLOT( compress() ) ); 
    connect( actionDecrypt, SIGNAL( triggered() ), this, SLOT( decrypt() ) );
    connect( actionEncrypt, SIGNAL( triggered() ), this, SLOT( encrypt() ) );
    connect( pushButton_IsoFromFolder_3, SIGNAL( triggered() ), this, SLOT( isocd() ) );
    connect( actionMerge_Splitted_Image, SIGNAL( triggered() ), this, SLOT( merge() ) );
    connect( actionSplit, SIGNAL( triggered() ), this, SLOT( split() ) );
    connect( actionExtract, SIGNAL( triggered() ), this, SLOT( uncompress() ) );
    connect( actionPlay, SIGNAL( triggered() ), this, SLOT( play() ) );
    connect( actionUmount_2, SIGNAL( triggered() ), this, SLOT( unplay() ) );
    connect( pushButton_GenCUE, SIGNAL( triggered() ), this, SLOT( gencue() ) );
    connect( actionMount_UDF_ISO_2, SIGNAL( triggered() ), this, SLOT( udf() ) );

connect( pushButton_5, SIGNAL( clicked() ), this, SLOT( on_options_nda_activated() ) );

    connect( actionRip_DVD_2_Xvid, SIGNAL( triggered() ), this, SLOT( rip() ) );
    connect( actionConvert_generic_video, SIGNAL( triggered() ), this, SLOT( vidgeneric() ) );
    connect( actionWithout_Account, SIGNAL( triggered() ), this, SLOT( utube() ) );
    connect( actionUser_Account_Login, SIGNAL( triggered() ), this, SLOT( utubeuser() ) );
    connect(actionUnmount_Image,SIGNAL( triggered() ), this, SLOT( umount() ) );
    //connect( actionPornTube_Download_Video, SIGNAL( triggered() ), this, SLOT( pornotube() ) );
    connect( actionMetaCafe_Download_Video, SIGNAL( triggered() ), this, SLOT( metacafe() ) );
    connect( actionConvert_FLV_2_AVI, SIGNAL( triggered() ), this, SLOT( flvavi() ) );
    connect( actionConvert_WMA_2_MP3, SIGNAL( triggered() ), this, SLOT( wma2wav() ) );
    connect( actionExtract_a_RAR_password_protectd, SIGNAL( triggered() ), this, SLOT( rar() ) );
    connect( actionGenerate_Md5, SIGNAL( triggered() ), this, SLOT( md5generate() ) );
    connect( actionCheck_Md5, SIGNAL( triggered() ), this, SLOT( md5check() ) );
    connect( actionGeneric_Mount_2, SIGNAL( triggered() ), this, SLOT( gmount() ) );
    connect( actionGeneric_Umount_2, SIGNAL( triggered() ), this, SLOT( gumount() ) );
    connect( actionGeneric_Floppy_Emulation_2, SIGNAL( triggered() ), this, SLOT( elfloppy() ) );
    connect( actionGeneric_No_Emulation_2, SIGNAL( triggered() ), this, SLOT( eltorito() ) );
    connect( actionExtract_Boot_Image_2, SIGNAL( triggered() ), this, SLOT( getboot() ) );
    connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOut(int, QProcess::ExitStatus)));
    connect( &MKisofs, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( initial_get_database() ));
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &GPg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutgpg(int, QProcess::ExitStatus)));
    connect( &PSxrip, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &PSxrip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutpsx(int, QProcess::ExitStatus)));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZip, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcompress(int, QProcess::ExitStatus)));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &SPlit, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutsplit(int, QProcess::ExitStatus)));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &PZipuncompress, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutuncompress(int, QProcess::ExitStatus)));
    connect( listWidget, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(mdatabase(QListWidgetItem *) ) );
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutisofromcd(int, QProcess::ExitStatus)));
    connect( &DD, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( initial_get_database() ));
    connect( listWidget_2, SIGNAL( itemDoubleClicked (QListWidgetItem *) ), this, SLOT(open_mounted(QListWidgetItem *) ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TAr, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(messaggio_poweriso()));
    connect( &POweriso, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &POweriso, SIGNAL(finished(int, QProcess::ExitStatus)), this,SLOT( message_extract_finish() ) );
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &CUe, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutcue(int, QProcess::ExitStatus)));
    connect( &BAckaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &BAckaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutbackaudio(int, QProcess::ExitStatus)));
    connect( &MAcimg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &MAcimg, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( printOutMACIMG(int, QProcess::ExitStatus) ) );
    connect( pushButton_delImage, SIGNAL( clicked() ), this, SLOT( remove_fromDatabase() ) );
    connect( pushButton_updateDB, SIGNAL( clicked() ), this, SLOT( initial_get_database() ) );
    connect( &WGet2, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &CAt, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( mergeMSG(int, QProcess::ExitStatus) ) );
    connect( &FUse, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutfuseiso(int, QProcess::ExitStatus)));
    connect( &ELtorito, SIGNAL( finished(int, QProcess::ExitStatus)), this,SLOT( closeProg() ) );
    connect( &TOc, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIp, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIp, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutrip(int, QProcess::ExitStatus)));
    connect( &RIp2, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIp2, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutrip2(int, QProcess::ExitStatus)));
    connect( &VIdgen, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &VIdgen, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutvidgen(int, QProcess::ExitStatus)));
    connect( &FLv, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &FLv, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutflv(int, QProcess::ExitStatus)));
    connect( &UTube, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &UTube, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOututube(int, QProcess::ExitStatus)));
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutaudiotools(int, QProcess::ExitStatus)));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &FUsermount, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutumount(int, QProcess::ExitStatus)));
    connect( &BIso, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &UCheck, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutucheck(int, QProcess::ExitStatus)));
    connect( actionRip_CD_Audio_2_MP, SIGNAL( triggered() ), this, SLOT( ripcdaudio() ) );
    connect( &RIpaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &RIpaudio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutripaudio(int, QProcess::ExitStatus)));
    connect( &AUdio, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutripaudio(int, QProcess::ExitStatus)));
    connect( actionExtract_Audio_from_any_Video_file, SIGNAL( triggered() ), this, SLOT( extractaudio() ) );
    connect( &extractaudiofromvideo, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT( closeProg() ));
    connect( &extractaudiofromvideo, SIGNAL(finished(int, QProcess::ExitStatus)), this, SLOT(printOutextractaudiofromvideo(int, QProcess::ExitStatus)));
    connect( lineEdit, SIGNAL( editingFinished() ), this, SLOT( search() ) );
    connect( lineEdit, SIGNAL( cursorPositionChanged ( int , int ) ), this, SLOT( search() ) );
    connect(dockWidget1, SIGNAL(dockLocationChanged(Qt::DockWidgetArea)),this, SLOT(setDockPos()));
    connect(listWidget, SIGNAL(customContextMenuRequested(const QPoint &)), this, SLOT(userListMenuRequested(const QPoint &))); 
	/*#############################################*/
//progressBar_burn->setVisible( false );

initial_get_database();
listWidget_2->setAcceptDrops(true);
//progress1Bar->setVisible( false );
splash->showMessage(tr("Loading Options..."));
createOption();
splash->finish(this);

/*QSystemTrayIcon *trayIcon;				//Tray Icon
trayIcon = new QSystemTrayIcon();
QIcon icon = QIcon(":/images/Acetino2.png");
trayIcon->setIcon(icon);
trayIcon->show();
trayIcon->setToolTip(tr("AcetoneISO I love You!"));*/
}

void acetoneiso::progBarra()
{
      prog.show();
}

void acetoneiso::closeProg()
{
prog.close();
}

void acetoneiso::on_options_nda_activated()
{
optionsDiag *opt=new optionsDiag;
opt->exec();
}

void acetoneiso::createOption()
{
QDir Home = QDir::home();
QFile file(Home.path() + "/.acetoneiso/acetoneiso.conf");
if( !file.exists() ) {
   file.open(QIODevice::WriteOnly | QIODevice::Text);
   QTextStream out(&file);
   out << ( "ISO_FROM_FOLDER = standard\n" );
   out << ( "PLAYER = kaffeine\n" );
   out << ( "FILE_BROWSER = kde\n" );
   out << ( "DB = " + Home.path() + "\n" );
   file.close();

QMessageBox::warning(this, "AcetoneISO::First Launch",tr("This is the first time you launch AcetoneISO software.\nIn the next dialog you can set your default file manager, set database and some other things.\nHappy AcetoneISO usage from the team:)"));
on_options_nda_activated();
   }


}

void acetoneiso::on_actionAbout_activated()
{
aboutDiag *abt=new aboutDiag;
abt->exec();
}

void acetoneiso::on_actionManual_activated()
{
manualDiag *man=new manualDiag;
man->exec();
}

void acetoneiso::search()
{
if( !lineEdit->text().isEmpty() ) {  //se la lineEdit non è vuota
   int elements = listWidget->count(); //numero totale di elementi nella lista
   int position = 0; 
//Nel ciclo while pongo come nascosti tutti gli elementi della lista
   while( position < elements ) {
      listWidget->item( position )->setHidden(true);
      position = position +1;
      }
   QList<QListWidgetItem *> found(listWidget->findItems( lineEdit->text(), Qt::MatchContains )); //cerca gli elementi che contengono la stringa nel lineEdit
   QListWidgetItem*  item;
//in questo ciclo pongo come visibili solo gli elementi che contengono nel proprio nome la stringa che cerco.
   foreach (item, found ) {
        item->setHidden(false);
	}
   }
else {
   initial_get_database();
   }
}

void acetoneiso::setDockPos()
{
QDir Home = QDir::home();
QFile windowStateFile(Home.path() + "/.acetoneiso/gui.state");
    QByteArray state = saveState();

    if(windowStateFile.open(QIODevice::WriteOnly))
    {
      windowStateFile.write(state);
      windowStateFile.close();
    }
}

void acetoneiso::setDockInit()
{
QDir Home = QDir::home();
QFile windowStateFile(Home.path() + "/.acetoneiso/gui.state");
    if(windowStateFile.open(QIODevice::ReadOnly))
    {
      QByteArray bytes = windowStateFile.readAll();
      restoreState(bytes);
      windowStateFile.close();
    }
}

void acetoneiso::userListMenuRequested(const QPoint & pos)
{
QIcon mount_icon( ":/images/dialog-ok-apply.png" );
QIcon delete_icon( ":/images/edit-delete.png" );
QIcon extract_icon( ":/images/buttTG.png" );

QMenu *userListMenu;
userListMenu = new QMenu();
QAction *mountAction = userListMenu->addAction( mount_icon,   tr("mount") );
QAction *deleteAction = userListMenu->addAction( delete_icon,  tr("delete") );
QAction *extractAction = userListMenu->addAction( extract_icon, tr("extract") );

    QPoint globalPos = listWidget->mapToGlobal(pos);    // Map the global position to the userlist
    QModelIndex t = listWidget->indexAt(pos);
    connect( mountAction,    SIGNAL( triggered() ), this, SLOT( menuMount() ) ); 
    connect( deleteAction,   SIGNAL( triggered() ), this, SLOT( remove_fromDatabase() ) );
    connect( extractAction,  SIGNAL( triggered() ), this, SLOT( contextExtract() ) );

    if( t.row() >= 0 ) { //previene un segfault se clicco col destro sullo spazio vuoto
       listWidget->item(t.row())->setSelected(true);         // even a right click will select the item
       fileDaMontare.clear();
       fileDaMontare = listWidget->item(t.row())->text();  //nome del file attuale      
       userListMenu->exec(globalPos);     
       }
}

